//***************************************************************
// Filename: 	FlashRead.c
//
// Brief:	This program reads flash and stores
//		the data to inputfile.
//		The program reads the size of an 
//		XC3S1000 configuration file
//
// Author:	Fredrik Gravdal, 2007, NTNU
//***************************************************************
#include <stdio.h>
#include <stdlib.h>
#include "FlashRead.h"

void readFPGAPart(int start, int end, char* fileToStore){
	printf("Reading FPGA part of Flash\n");
	
	FILE * pFile;
  	pFile = fopen (fileToStore,"wb");

	unsigned short tmp_data;	
	if (pFile!=NULL){ 
		for(start; start<end ; start+=2){	
			tmp_data = (*(volatile unsigned short *) (start));
			fwrite(&tmp_data, 2,1, pFile);
		}
		fclose (pFile);
  		printf("Finished reading.. \n");
	}
	else {
		printf("Error! :(\n");
	}
}

int main(int numArgs, char* argc[]){
	readFPGAPart(FLASH_START+FPGA_START, FLASH_START+FPGA_START+0x725F8, argc[1]);	
	return 0;
}
